net.sf.saxon.event

## Class PipelineConfiguration

- java.lang.Object
- - net.sf.saxon.event.PipelineConfiguration

-     public class PipelineConfiguration
      extends Object

  A PipelineConfiguration sets options that apply to all the operations in a pipeline. Unlike the global Configuration, these options are always local to a process.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PipelineConfiguration(Configuration config)` Create a PipelineConfiguration.
    `PipelineConfiguration(PipelineConfiguration p)` Create a PipelineConfiguration as a copy of an existing PipelineConfiguration

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Stack<Item>` | `getAppliedItemStack()`
    `Object` | `getComponent(String name)` Get a named component of the pipeline
    `Configuration` | `getConfiguration()` Get the Saxon Configuration object
    `Controller` | `getController()` Get the controller associated with this pipelineConfiguration
    `ErrorListener` | `getErrorListener()` Get an ErrorListener for reporting errors in processing this pipeline; this will be the ErrorListener set locally in the PipelineConfiguration if there is one, or the ErrorListener from the Configuration otherwise.
    `int` | `getHostLanguage()` Get the host language in use
    `ErrorListener` | `getLocalErrorListener()` Get the ErrorListener set as a property of this pipeline
    `LocationProvider` | `getLocationProvider()` Get the LocationProvider for interpreting location ids passed down this pipeline
    `ParseOptions` | `getParseOptions()` Get the document parsing and building options to be used on this pipeline return the options to be used
    `SchemaURIResolver` | `getSchemaURIResolver()` Get the user-defined SchemaURIResolver for resolving URIs used in "import schema" declarations; returns null if none has been explicitly set.
    `SourceLocator` | `getSourceLocation(long locationId)` Get a SourceLocator for a given locationId, using this location provider
    `URIResolver` | `getURIResolver()` Get the URIResolver used for processing URIs encountered on this pipeline
    `boolean` | `isExpandAttributeDefaults()` Ask whether attribute defaults defined in a schema or DTD are to be expanded or not (by default, fixed and default attribute values are expanded, that is, they are inserted into the document during validation as if they were present in the instance being validated)
    `boolean` | `isRecoverFromValidationErrors()` Ask if this pipeline recovers from validation errors
    `boolean` | `isSerializing()` Ask whether this pipeline is a serializing pipeline
    `Item` | `peekCurrentAppliedItem()`
    `void` | `popCurrentAppliedItem()` Get the context item.
    `void` | `pushCurrentAppliedItem(Item item)` Set the context item.
    `void` | `setComponent(String name, Object value)` Set a named component of the pipeline
    `void` | `setConfiguration(Configuration config)` Set the Saxon Configuration object
    `void` | `setController(Controller controller)` Set the Controller associated with this pipelineConfiguration
    `void` | `setErrorListener(ErrorListener errorListener)` Set the ErrorListener used for reporting errors in processing this pipeline
    `void` | `setExpandAttributeDefaults(boolean expand)` Set whether attribute defaults defined in a schema or DTD are to be expanded or not (by default, fixed and default attribute values are expanded, that is, they are inserted into the document during validation as if they were present in the instance being validated)
    `void` | `setHostLanguage(int language)` Set the host language in use
    `void` | `setLocationProvider(LocationProvider locationProvider)` Set the LocationProvider for interpreting location ids passed down this pipeline
    `void` | `setParseOptions(ParseOptions options)` Set the document parsing and building options to be used on this pipeline
    `void` | `setRecoverFromValidationErrors(boolean recover)` Say whether validation errors encountered on this pipeline should be treated as fatal or as recoverable.
    `void` | `setSchemaURIResolver(SchemaURIResolver resolver)` Set a user-defined SchemaURIResolver for resolving URIs used in "import schema" declarations.
    `void` | `setSerializing(boolean isSerializing)` Set whether this pipeline is a serializing pipeline
    `void` | `setURIResolver(URIResolver uriResolver)` Set the URIResolver used for processing URIs encountered on this pipeline
    `void` | `setUseXsiSchemaLocation(boolean recognize)` Say whether xsi:schemaLocation and xsi:noNamespaceSchemaLocation attributes should be recognized while validating an instance document

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PipelineConfiguration

          public PipelineConfiguration(Configuration config)

      Create a PipelineConfiguration. Note: the normal way to create a PipelineConfiguration is via the factory methods in the Controller and Configuration classes
      Parameters:
        `config` - the Saxon configuration
      See Also:
        `Configuration.makePipelineConfiguration()`, `Controller.makePipelineConfiguration()`

    - #### PipelineConfiguration

          public PipelineConfiguration(PipelineConfiguration p)

      Create a PipelineConfiguration as a copy of an existing PipelineConfiguration
      Parameters:
        `p` - the existing PipelineConfiguration

  - ### Method Detail

    - #### getConfiguration

          public Configuration getConfiguration()

      Get the Saxon Configuration object
      Returns:
        the Saxon Configuration

    - #### setConfiguration

          public void setConfiguration(Configuration config)

      Set the Saxon Configuration object
      Parameters:
        `config` - the Saxon Configuration

    - #### getLocationProvider

          public LocationProvider getLocationProvider()

      Get the LocationProvider for interpreting location ids passed down this pipeline
      Returns:
        the appropriate LocationProvider

    - #### setLocationProvider

          public void setLocationProvider(LocationProvider locationProvider)

      Set the LocationProvider for interpreting location ids passed down this pipeline
      Parameters:
        `locationProvider` - the LocationProvider

    - #### getSourceLocation

          public SourceLocator getSourceLocation(long locationId)

      Get a SourceLocator for a given locationId, using this location provider
      Parameters:
        `locationId` - an integer identifier for a source location
      Returns:
        an object holding location information

    - #### getLocalErrorListener

          public ErrorListener getLocalErrorListener()

      Get the ErrorListener set as a property of this pipeline
      Returns:
        the ErrorListener; null if none has been set.

    - #### getErrorListener

          public ErrorListener getErrorListener()

      Get an ErrorListener for reporting errors in processing this pipeline; this will be the ErrorListener set locally in the PipelineConfiguration if there is one, or the ErrorListener from the Configuration otherwise.
      Returns:
        the ErrorListener to be used; never null

    - #### setErrorListener

          public void setErrorListener(ErrorListener errorListener)

      Set the ErrorListener used for reporting errors in processing this pipeline
      Parameters:
        `errorListener` - the ErrorListener

    - #### getURIResolver

          public URIResolver getURIResolver()

      Get the URIResolver used for processing URIs encountered on this pipeline
      Returns:
        the URIResolver

    - #### setURIResolver

          public void setURIResolver(URIResolver uriResolver)

      Set the URIResolver used for processing URIs encountered on this pipeline
      Parameters:
        `uriResolver` - the URIResolver

    - #### getSchemaURIResolver

          public SchemaURIResolver getSchemaURIResolver()

      Get the user-defined SchemaURIResolver for resolving URIs used in "import schema" declarations; returns null if none has been explicitly set.
      Returns:
        the SchemaURIResolver

    - #### setParseOptions

          public void setParseOptions(ParseOptions options)

      Set the document parsing and building options to be used on this pipeline
      Parameters:
        `options` - the options to be used

    - #### getParseOptions

          public ParseOptions getParseOptions()

      Get the document parsing and building options to be used on this pipeline return the options to be used
      Returns:
        the parser options for this pipeline

    - #### setUseXsiSchemaLocation

          public void setUseXsiSchemaLocation(boolean recognize)

      Say whether xsi:schemaLocation and xsi:noNamespaceSchemaLocation attributes should be recognized while validating an instance document
      Parameters:
        `recognize` - true if these attributes should be recognized

    - #### setRecoverFromValidationErrors

          public void setRecoverFromValidationErrors(boolean recover)

      Say whether validation errors encountered on this pipeline should be treated as fatal or as recoverable.

      Note this is a shortcut for `getParseOptions().setContinueAfterValidationErrors()`, retained for backwards compatibility.

      Parameters:
        `recover` - set to true if validation errors are to be treated as recoverable. If this option is set to true, such errors will be reported to the ErrorListener using the error() method, and validation will continue. If it is set to false, errors will be reported using the fatalError() method, and validation will be abandoned. The default depends on the circumstances: typically during standalone instance validation the default is true, but during XSLT and XQuery processing it is false.

    - #### isRecoverFromValidationErrors

          public boolean isRecoverFromValidationErrors()

      Ask if this pipeline recovers from validation errors

      Note this is a shortcut for `getParseOptions().isContinueAfterValidationErrors()`, retained for backwards compatibility.

      Returns:
        true if validation errors on this pipeline are treated as recoverable; false if they are treated as fatal

    - #### setSchemaURIResolver

          public void setSchemaURIResolver(SchemaURIResolver resolver)

      Set a user-defined SchemaURIResolver for resolving URIs used in "import schema" declarations.
      Parameters:
        `resolver` - the SchemaURIResolver

    - #### getController

          public Controller getController()

      Get the controller associated with this pipelineConfiguration
      Returns:
        the controller if it is known; otherwise null.

    - #### pushCurrentAppliedItem

          public void pushCurrentAppliedItem(Item item)

      Set the context item. Used only for diagnostics, to indicate what part of the source document is being processed. Maintained only by XSLT instructions that change the context, e.g. for-each, apply-templates, iterate, and for-each-group
      Parameters:
        `contextIterator` - the context iterator (whose current item is the context item)

    - #### popCurrentAppliedItem

          public void popCurrentAppliedItem()

      Get the context item. Used only for diagnostics, to indicate what part of the source document is being processed. Maintained only by XSLT instructions that change the context, e.g. for-each, apply-templates, iterate, and for-each-group

    - #### peekCurrentAppliedItem

          public Item peekCurrentAppliedItem()

    - #### getAppliedItemStack

          public Stack<Item> getAppliedItemStack()

    - #### setController

          public void setController(Controller controller)

      Set the Controller associated with this pipelineConfiguration
      Parameters:
        `controller` - the Controller

    - #### getHostLanguage

          public int getHostLanguage()

      Get the host language in use
      Returns:
        for example `Configuration.XSLT` or `Configuration.XQUERY`

    - #### setHostLanguage

          public void setHostLanguage(int language)

      Set the host language in use
      Parameters:
        `language` - for example `Configuration.XSLT` or `Configuration.XQUERY`

    - #### isSerializing

          public boolean isSerializing()

      Ask whether this pipeline is a serializing pipeline
      Returns:
        true if this pipeline is producing serialized output

    - #### setSerializing

          public void setSerializing(boolean isSerializing)

      Set whether this pipeline is a serializing pipeline
      Parameters:
        `isSerializing` - true if this pipeline is producing serialized output

    - #### setExpandAttributeDefaults

          public void setExpandAttributeDefaults(boolean expand)

      Set whether attribute defaults defined in a schema or DTD are to be expanded or not (by default, fixed and default attribute values are expanded, that is, they are inserted into the document during validation as if they were present in the instance being validated)
      Parameters:
        `expand` - true if defaults are to be expanded, false if not

    - #### isExpandAttributeDefaults

          public boolean isExpandAttributeDefaults()

      Ask whether attribute defaults defined in a schema or DTD are to be expanded or not (by default, fixed and default attribute values are expanded, that is, they are inserted into the document during validation as if they were present in the instance being validated)
      Returns:
        true if defaults are to be expanded, false if not

    - #### setComponent

          public void setComponent(String name,
                          Object value)

      Set a named component of the pipeline
      Parameters:
        `name` - string the component name
        `value` - the component value

    - #### getComponent

          public Object getComponent(String name)

      Get a named component of the pipeline
      Parameters:
        `name` - string the component name
      Returns:
        the component value, or null if absent

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.